IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[HDOSYA_LABSONUC_LISTE_TARIHLI_OZET]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION [dbo].HDOSYA_LABSONUC_LISTE_TARIHLI_OZET
GO


CREATE FUNCTION [dbo].[HDOSYA_LABSONUC_LISTE_TARIHLI_OZET] (@HDOSYAID AS INT,@GIRISTARIH AS DATETIME, @AYRAC AS NVARCHAR(5))  
RETURNS NVARCHAR(4000) AS  
BEGIN 
	DECLARE 
	    @TESTSONUCLISTE AS NVARCHAR(4000),
	    @TETKIKTESTSONUC AS NVARCHAR(3000),
	    @HTETKIKID INT,
	    @TESTSONUC AS NVARCHAR(200),  
	    @RAPORBASLIK AS NVARCHAR(100),
	    @BASLIKYAZ AS BIT,
		@OLCUM AS NVARCHAR(100),
		@BIRIM AS NVARCHAR(20),
		--@MIND AS NVARCHAR(10),
		--@MAXD AS NVARCHAR(10) ,
		@SONUCR AS NVARCHAR(10),
		@SONUCY AS NVARCHAR(20),
		--@REFD AS NVARCHAR(10), 
		@TETKIKTURID AS INT,
		@TETKIKTURADI AS NVARCHAR(100),
		@SONUCTARIH AS DATETIME,
		@SAKLITETKIKTURID AS INT,
		@SAKLISONUCTARIH AS DATETIME,
		@TURADISONUCTRHBASLIKEKLE AS BIT
		
	    
	SET @TESTSONUCLISTE = '' 
	SET @TURADISONUCTRHBASLIKEKLE = 0

	DECLARE HDOSYA_LABTETKIK_CURSOR CURSOR
	FOR SELECT HTETKIKID, RAPORBASLIK, BASLIKYAZ, TETKIKTURID, TETKIKTURADI, SONUCTARIH FROM VWTETKIK WHERE ( HDOSYAID = @HDOSYAID AND GIRISTARIH=@GIRISTARIH AND UYGBOLUMTURU = 2)
	ORDER BY dbo.TARIHAL(SONUCTARIH), TETKIKTURID

	OPEN HDOSYA_LABTETKIK_CURSOR 
	FETCH NEXT FROM HDOSYA_LABTETKIK_CURSOR INTO @HTETKIKID, @RAPORBASLIK, @BASLIKYAZ, @TETKIKTURID, @TETKIKTURADI, @SONUCTARIH

	WHILE @@FETCH_STATUS = 0
	BEGIN
        SET @TETKIKTESTSONUC = ''
		IF @SAKLITETKIKTURID IS NULL OR @SAKLISONUCTARIH IS NULL OR (@TETKIKTURID <> @SAKLITETKIKTURID) OR (dbo.TARIHAL(@SONUCTARIH) <> @SAKLISONUCTARIH) 
		BEGIN 
		  SET @TURADISONUCTRHBASLIKEKLE = 1
		  SET @SAKLITETKIKTURID = @TETKIKTURID
		  SET @SAKLISONUCTARIH = dbo.TARIHAL(@SONUCTARIH)
		END

		DECLARE HDOSYA_LABTETKIK_TEST_CURSOR CURSOR
		FOR SELECT OLCUM,CAST(SONUCR AS NVARCHAR(10)),BIRIM,SONUCY
		          --, CAST(MIND AS NVARCHAR(10)),CAST(MAXD AS NVARCHAR(10)),CAST(REFD AS NVARCHAR(10))  
		    FROM HTETKIKDETAY INNER JOIN HTETKIK ON HTETKIK.HTETKIKID=HTETKIKDETAY.HTETKIKID WHERE HTETKIK.HTETKIKID = @HTETKIKID
		OPEN HDOSYA_LABTETKIK_TEST_CURSOR 
		--FETCH NEXT FROM HDOSYA_LABTETKIK_TEST_CURSOR INTO @OLCUM,@SONUCR,@BIRIM,@SONUCY,@MIND,@MAXD,@REFD
		FETCH NEXT FROM HDOSYA_LABTETKIK_TEST_CURSOR INTO @OLCUM,@SONUCR,@BIRIM,@SONUCY
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
			SET @TESTSONUC = ''			
			IF @OLCUM IS NULL  SET @OLCUM=''   ELSE SET @OLCUM=@OLCUM  +':'
			IF @SONUCR IS NULL SET @SONUCR=''  ELSE SET @SONUCR=' '+@SONUCR
			IF @SONUCY IS NULL SET @SONUCY=''  ELSE SET @SONUCY=' '+@SONUCY
			
			IF @SONUCR <> '' OR @SONUCY <> ''
			BEGIN
				IF @BIRIM IS NULL  SET @BIRIM=''   ELSE SET @BIRIM=' '+@BIRIM
				--IF @MIND IS NULL SET @MIND='' ELSE SET @MIND=' '+@MIND+'-' 
				--IF @MAXD IS NULL SET @MAXD='' ELSE SET @MAXD=@MAXD
				--IF @MIND='' AND @MAXD<>'' SET @MAXD = ' -'+@MAXD  
				--IF @REFD IS NULL SET @REFD='' ELSE SET @REFD=' ' + @REFD
				--SET @TESTSONUC = @OLCUM+@SONUCR+@SONUCY+@BIRIM+@MIND+@MAXD+@REFD
				SET @TESTSONUC = @OLCUM+@SONUCR+@SONUCY+@BIRIM
				SET @TETKIKTESTSONUC = @TETKIKTESTSONUC+@TESTSONUC+@AYRAC
			END
			
			--FETCH NEXT FROM HDOSYA_LABTETKIK_TEST_CURSOR  INTO @OLCUM,@SONUCR,@BIRIM,@SONUCY,@MIND,@MAXD,@REFD    
			FETCH NEXT FROM HDOSYA_LABTETKIK_TEST_CURSOR  INTO @OLCUM,@SONUCR,@BIRIM,@SONUCY    
		END
		
		IF @TETKIKTESTSONUC <> ''
		BEGIN
		   --IF @BASLIKYAZ = 1
		   -- SET @TETKIKTESTSONUC = @RAPORBASLIK + ' ' + @TETKIKTESTSONUC
		    
		  -- IF @TURADISONUCTRHBASLIKEKLE = 1
		  -- BEGIN
          --   SET @TETKIKTESTSONUC = CHAR(13)+'> '+ISNULL(@TETKIKTURADI+' ','') 
			
			-- + @TETKIKTESTSONUC
            -- SET @TURADISONUCTRHBASLIKEKLE = 0
          -- END
		   		    
		   IF @TESTSONUCLISTE <> ''
		     SET @TESTSONUCLISTE = @TESTSONUCLISTE + ' '
		   SET @TESTSONUCLISTE = @TESTSONUCLISTE + @TETKIKTESTSONUC	
		END

		CLOSE HDOSYA_LABTETKIK_TEST_CURSOR
		DEALLOCATE HDOSYA_LABTETKIK_TEST_CURSOR		
		
		FETCH NEXT FROM HDOSYA_LABTETKIK_CURSOR INTO @HTETKIKID, @RAPORBASLIK, @BASLIKYAZ, @TETKIKTURID, @TETKIKTURADI, @SONUCTARIH
	END
	CLOSE HDOSYA_LABTETKIK_CURSOR
	DEALLOCATE HDOSYA_LABTETKIK_CURSOR		
	RETURN @TESTSONUCLISTE
END







GO


